!******************************************************************************!
!                                                                              !
!    ctparameter148.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter148.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2016                                 |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-04-01 12:00             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter148
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter148()
  if (dMM_QED2_scheme .eq. 0) then
    dMM_QED2 = (2d0*Ten438*cMM*coupl(nGC_4)**2d0 + Ten439*cMM*(-coupl(nGC_101  &
               )**2d0 - 2d0*coupl(nGC_101)*coupl(nGC_102) - coupl(nGC_102)**2d0&
                - 2d0*coupl(nGC_52)**2d0 + 8d0*coupl(nGC_52)*coupl(nGC_55) -   &
               2d0*coupl(nGC_55)**2d0)/2d0 + Ten440*cMM*coupl(nGC_103)**2d0 +  &
               Ten441*cMM*coupl(nGC_104)**2d0 - 2d0*Ten442*cMM*coupl(nGC_4)**  &
               2d0 + Ten443*cMM*(coupl(nGC_100)**2d0 + 2d0*coupl(nGC_33)**2d0)/&
               2d0 + Ten444*cMM*(-coupl(nGC_101)*coupl(nGC_102) - coupl(nGC_52 &
               )**2d0 - coupl(nGC_55)**2d0) - Ten445*cMM*coupl(nGC_103)**2d0 - &
               Ten446*cMM*coupl(nGC_104)**2d0 + 2d0*Ten447*cMM*coupl(nGC_103)**&
               2d0*rMM*(-cMM + rMM) + 2d0*Ten448*cMM*coupl(nGC_104)**2d0*rMM*(-&
               cMM + rMM) + 4d0*Ten449*coupl(nGC_4)**2d0*rMM*(2d0*cMM**2d0 -   &
               3d0*cMM*rMM + rMM**2d0) + Ten450*rMM*(-cMM**2d0*coupl(nGC_101)**&
               2d0 - cMM**2d0*coupl(nGC_102)**2d0 + 8d0*cMM**2d0*coupl(nGC_52)*&
               coupl(nGC_55) + cMM*coupl(nGC_101)**2d0*rMM - 2d0*cMM*coupl(    &
               nGC_101)*coupl(nGC_102)*rMM + cMM*coupl(nGC_102)**2d0*rMM - 2d0*&
               cMM*coupl(nGC_52)**2d0*rMM - 8d0*cMM*coupl(nGC_52)*coupl(nGC_55 &
               )*rMM - 2d0*cMM*coupl(nGC_55)**2d0*rMM + 2d0*coupl(nGC_101)*    &
               coupl(nGC_102)*rMM**2d0 + 2d0*coupl(nGC_52)**2d0*rMM**2d0 + 2d0*&
               coupl(nGC_55)**2d0*rMM**2d0) + 2d0*Ten451*coupl(nGC_103)**2d0*  &
               rMM**2d0*(cMM - rMM) + 2d0*Ten452*coupl(nGC_104)**2d0*rMM**2d0*(&
               cMM - rMM) + 4d0*Ten453*coupl(nGC_4)**2d0*rMM**2d0*(-cMM + rMM  &
               ) + Ten454*rMM**2d0*(cMM*coupl(nGC_100)**2d0 + 2d0*cMM*coupl(   &
               nGC_33)**2d0 - coupl(nGC_100)**2d0*rMM - 2d0*coupl(nGC_33)**2d0*&
               rMM) + 2d0*Ten455*rMM**2d0*(-cMM*coupl(nGC_101)*coupl(nGC_102   &
               ) - cMM*coupl(nGC_52)**2d0 - cMM*coupl(nGC_55)**2d0 + coupl(    &
               nGC_101)*coupl(nGC_102)*rMM + coupl(nGC_52)**2d0*rMM + coupl(   &
               nGC_55)**2d0*rMM) + pi**2d0*(-8d0*aEW*cMM**2d0/(pi*rMM) + 8d0*  &
               aEW*rMM/pi + cMM*coupl(nGC_33)**2d0/(2d0*pi**2d0) - cMM*coupl(  &
               nGC_4)**2d0/pi**2d0 + cMM*coupl(nGC_52)**2d0/(2d0*pi**2d0) - 2d0&
               *cMM*coupl(nGC_52)*coupl(nGC_55)/pi**2d0 + cMM*coupl(nGC_55)**  &
               2d0/(2d0*pi**2d0)))/(16d0*pi**2d0) + cima*coupl(nGC_104)*       &
               dtHl_QED1/cMHL**2d0 + cima*coupl(nGC_103)*dtHh_QED1/cMHH**2d0
    if (.not. complex_mass_scheme) then
      dMM_QED2 = cone*real(dMM_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter148
end module ctparameter148
