!******************************************************************************!
!                                                                              !
!    ctparameter151.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter151.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2016                                 |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-04-01 12:00             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter151
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter151()
  DeltaUV = DeltaUV + log(muUV**2/muMS**2)
  dZHhHl_MS_QED2 = DeltaUV*(24d0*Nc*cMB**2d0*coupl(nGC_83)*coupl(nGC_84)*rMHH**&
                   2d0 - 24d0*Nc*cMB**2d0*coupl(nGC_83)*coupl(nGC_84)*rMHL**2d0&
                    + 24d0*Nc*cMC**2d0*coupl(nGC_88)*coupl(nGC_89)*rMHH**2d0 - &
                   24d0*Nc*cMC**2d0*coupl(nGC_88)*coupl(nGC_89)*rMHL**2d0 +    &
                   24d0*Nc*cMD**2d0*coupl(nGC_93)*coupl(nGC_94)*rMHH**2d0 -    &
                   24d0*Nc*cMD**2d0*coupl(nGC_93)*coupl(nGC_94)*rMHL**2d0 - 4d0&
                   *Nc*cMHL**2d0*coupl(nGC_108)*coupl(nGC_109)*rMHH**2d0 + 4d0*&
                   Nc*cMHL**2d0*coupl(nGC_108)*coupl(nGC_109)*rMHL**2d0 - 4d0* &
                   Nc*cMHL**2d0*coupl(nGC_113)*coupl(nGC_114)*rMHH**2d0 + 4d0* &
                   Nc*cMHL**2d0*coupl(nGC_113)*coupl(nGC_114)*rMHL**2d0 - 4d0* &
                   Nc*cMHL**2d0*coupl(nGC_123)*coupl(nGC_124)*rMHH**2d0 + 4d0* &
                   Nc*cMHL**2d0*coupl(nGC_123)*coupl(nGC_124)*rMHL**2d0 - 4d0* &
                   Nc*cMHL**2d0*coupl(nGC_83)*coupl(nGC_84)*rMHH**2d0 + 4d0*Nc*&
                   cMHL**2d0*coupl(nGC_83)*coupl(nGC_84)*rMHL**2d0 - 4d0*Nc*   &
                   cMHL**2d0*coupl(nGC_88)*coupl(nGC_89)*rMHH**2d0 + 4d0*Nc*   &
                   cMHL**2d0*coupl(nGC_88)*coupl(nGC_89)*rMHL**2d0 - 4d0*Nc*   &
                   cMHL**2d0*coupl(nGC_93)*coupl(nGC_94)*rMHH**2d0 + 4d0*Nc*   &
                   cMHL**2d0*coupl(nGC_93)*coupl(nGC_94)*rMHL**2d0 + 24d0*Nc*  &
                   cMS**2d0*coupl(nGC_108)*coupl(nGC_109)*rMHH**2d0 - 24d0*Nc* &
                   cMS**2d0*coupl(nGC_108)*coupl(nGC_109)*rMHL**2d0 + 24d0*Nc* &
                   cMT**2d0*coupl(nGC_113)*coupl(nGC_114)*rMHH**2d0 - 24d0*Nc* &
                   cMT**2d0*coupl(nGC_113)*coupl(nGC_114)*rMHL**2d0 + 24d0*Nc* &
                   cMU**2d0*coupl(nGC_123)*coupl(nGC_124)*rMHH**2d0 - 24d0*Nc* &
                   cMU**2d0*coupl(nGC_123)*coupl(nGC_124)*rMHL**2d0 + 24d0*cME &
                   **2d0*coupl(nGC_98)*coupl(nGC_99)*rMHH**2d0 - 24d0*cME**2d0*&
                   coupl(nGC_98)*coupl(nGC_99)*rMHL**2d0 + cima*cMHH**2d0*coupl&
                   (nGC_22)*rMHH**2d0 - cima*cMHH**2d0*coupl(nGC_22)*rMHL**2d0 &
                    - 4d0*cMHL**2d0*coupl(nGC_103)*coupl(nGC_104)*rMHH**2d0 +  &
                   4d0*cMHL**2d0*coupl(nGC_103)*coupl(nGC_104)*rMHL**2d0 - 4d0*&
                   cMHL**2d0*coupl(nGC_118)*coupl(nGC_119)*rMHH**2d0 + 4d0*cMHL&
                   **2d0*coupl(nGC_118)*coupl(nGC_119)*rMHL**2d0 + cima*cMHL** &
                   2d0*coupl(nGC_21)*rMHH**2d0 - cima*cMHL**2d0*coupl(nGC_21)* &
                   rMHL**2d0 - 4d0*cMHL**2d0*coupl(nGC_34)*coupl(nGC_46)*rMHH**&
                   2d0 + 4d0*cMHL**2d0*coupl(nGC_34)*coupl(nGC_46)*rMHL**2d0 - &
                   4d0*cMHL**2d0*coupl(nGC_35)*coupl(nGC_47)*rMHH**2d0 + 4d0*  &
                   cMHL**2d0*coupl(nGC_35)*coupl(nGC_47)*rMHL**2d0 - 4d0*cMHL**&
                   2d0*coupl(nGC_57)*coupl(nGC_61)*rMHH**2d0 + 4d0*cMHL**2d0*  &
                   coupl(nGC_57)*coupl(nGC_61)*rMHL**2d0 - 4d0*cMHL**2d0*coupl(&
                   nGC_98)*coupl(nGC_99)*rMHH**2d0 + 4d0*cMHL**2d0*coupl(nGC_98&
                   )*coupl(nGC_99)*rMHL**2d0 + 24d0*cMM**2d0*coupl(nGC_103)*   &
                   coupl(nGC_104)*rMHH**2d0 - 24d0*cMM**2d0*coupl(nGC_103)*    &
                   coupl(nGC_104)*rMHL**2d0 + 24d0*cMTA**2d0*coupl(nGC_118)*   &
                   coupl(nGC_119)*rMHH**2d0 - 24d0*cMTA**2d0*coupl(nGC_118)*   &
                   coupl(nGC_119)*rMHL**2d0 + 2d0*cima*cMW**2d0*coupl(nGC_18)* &
                   rMHH**2d0 - 2d0*cima*cMW**2d0*coupl(nGC_18)*rMHL**2d0 - 8d0*&
                   cima*cMW**2d0*coupl(nGC_30)*rMHH**2d0 + 8d0*cima*cMW**2d0*  &
                   coupl(nGC_30)*rMHL**2d0 - 4d0*cMW**2d0*coupl(nGC_34)*coupl( &
                   nGC_46)*rMHH**2d0 + 4d0*cMW**2d0*coupl(nGC_34)*coupl(nGC_46 &
                   )*rMHL**2d0 - 4d0*cMW**2d0*coupl(nGC_35)*coupl(nGC_47)*rMHH &
                   **2d0 + 4d0*cMW**2d0*coupl(nGC_35)*coupl(nGC_47)*rMHL**2d0  &
                    + cima*cMZ**2d0*coupl(nGC_18)*rMHH**2d0 - cima*cMZ**2d0*   &
                   coupl(nGC_18)*rMHL**2d0 - 4d0*cMZ**2d0*coupl(nGC_57)*coupl( &
                   nGC_61)*rMHH**2d0 + 4d0*cMZ**2d0*coupl(nGC_57)*coupl(nGC_61 &
                   )*rMHL**2d0 - 4d0*cima*cMZ**2d0*coupl(nGC_66)*rMHH**2d0 +   &
                   4d0*cima*cMZ**2d0*coupl(nGC_66)*rMHL**2d0 + 4d0*coupl(nGC_44&
                   )*coupl(nGC_49)*rMHH**2d0 - 4d0*coupl(nGC_44)*coupl(nGC_49)*&
                   rMHL**2d0 + 2d0*coupl(nGC_60)*coupl(nGC_62)*rMHH**2d0 - 2d0*&
                   coupl(nGC_60)*coupl(nGC_62)*rMHL**2d0 - 8d0*coupl(nGC_69)*  &
                   coupl(nGC_70)*rMHH**2d0 + 8d0*coupl(nGC_69)*coupl(nGC_70)*  &
                   rMHL**2d0 - 4d0*coupl(nGC_72)*coupl(nGC_73)*rMHH**2d0 + 4d0*&
                   coupl(nGC_72)*coupl(nGC_73)*rMHL**2d0 - 3d0*coupl(nGC_74)*  &
                   coupl(nGC_75)*rMHH**2d0 + 3d0*coupl(nGC_74)*coupl(nGC_75)*  &
                   rMHL**2d0 - coupl(nGC_76)*coupl(nGC_78)*rMHH**2d0 + coupl(  &
                   nGC_76)*coupl(nGC_78)*rMHL**2d0 - 2d0*coupl(nGC_76)*coupl(  &
                   nGC_79)*rMHH**2d0 + 2d0*coupl(nGC_76)*coupl(nGC_79)*rMHL**  &
                   2d0 - coupl(nGC_77)*coupl(nGC_79)*rMHH**2d0 + coupl(nGC_77)*&
                   coupl(nGC_79)*rMHL**2d0)/(16d0*pi**2d0*(cMHH**2d0*rMHH**2d0 &
                    - cMHH**2d0*rMHL**2d0 - cMHL**2d0*rMHH**2d0 + cMHL**2d0*   &
                   rMHL**2d0)) + 2d0*cima*coupl(nGC_79)*dtHl_MS_QED1*(rMHH**2d0&
                    - rMHL**2d0)/(cMHL**2d0*(cMHH**2d0*rMHH**2d0 - cMHH**2d0*  &
                   rMHL**2d0 - cMHL**2d0*rMHH**2d0 + cMHL**2d0*rMHL**2d0)) +   &
                   2d0*cima*coupl(nGC_76)*dtHh_MS_QED1*(rMHH**2d0 - rMHL**2d0  &
                   )/(cMHH**2d0*(cMHH**2d0*rMHH**2d0 - cMHH**2d0*rMHL**2d0 -   &
                   cMHL**2d0*rMHH**2d0 + cMHL**2d0*rMHL**2d0))
    if (.not. complex_mass_scheme) then
      dZHhHl_MS_QED2 = cone*real(dZHhHl_MS_QED2,kind=dp)
    end if 
  DeltaUV = DeltaUV - log(muUV**2/muMS**2)
end subroutine set_ctparameter151
end module ctparameter151
