!******************************************************************************!
!                                                                              !
!    ctparameter27.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter27.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2016                                 |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-04-01 12:00             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter27
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter27()
  if (dZtauMinusR_QED2_scheme .eq. 0) then
    dZtauMinusR_QED2 = (2d0*Ten474*coupl(nGC_4)**2d0 + Ten475*(coupl(nGC_116)* &
                       coupl(nGC_117) + 2d0*coupl(nGC_52)**2d0) - Ten476*coupl(&
                       nGC_119)**2d0 - Ten477*coupl(nGC_118)**2d0 + 2d0*Ten478*&
                       coupl(nGC_4)**2d0 - Ten479*coupl(nGC_115)**2d0 + Ten480 &
                       *(coupl(nGC_116)*coupl(nGC_117) + 2d0*coupl(nGC_52)**2d0&
                       ) + 2d0*Ten483*cMTA*coupl(nGC_119)**2d0*rMTA + 2d0*     &
                       Ten484*cMTA*coupl(nGC_118)**2d0*rMTA + 4d0*Ten485*coupl(&
                       nGC_4)**2d0*rMTA*(-2d0*cMTA + rMTA) + Ten486*rMTA*(cMTA*&
                       coupl(nGC_116)**2d0 + cMTA*coupl(nGC_117)**2d0 - 8d0*   &
                       cMTA*coupl(nGC_52)*coupl(nGC_55) + 2d0*coupl(nGC_116)*  &
                       coupl(nGC_117)*rMTA + 2d0*coupl(nGC_52)**2d0*rMTA + 2d0*&
                       coupl(nGC_55)**2d0*rMTA) - 2d0*Ten487*coupl(nGC_119)**  &
                       2d0*rMTA**2d0 - 2d0*Ten488*coupl(nGC_118)**2d0*rMTA**2d0&
                        + 4d0*Ten489*coupl(nGC_4)**2d0*rMTA**2d0 + Ten490*rMTA &
                       **2d0*(-coupl(nGC_115)**2d0 - 2d0*coupl(nGC_33)**2d0) + &
                       2d0*Ten491*rMTA**2d0*(coupl(nGC_116)*coupl(nGC_117) +   &
                       coupl(nGC_52)**2d0 + coupl(nGC_55)**2d0) + pi**2d0*(-   &
                       coupl(nGC_4)**2d0/pi**2d0 - coupl(nGC_52)**2d0/pi**2d0  &
                       ))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZtauMinusR_QED2 = cone*real(dZtauMinusR_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter27
end module ctparameter27
