!******************************************************************************!
!                                                                              !
!    ctparameter74.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter74.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2016                                 |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-04-01 12:00             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter74
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter74()
  if (dZuL_QED2_scheme .eq. 1) then
    dZuL_QED2 = (2d0*Ten243*coupl(nGC_2)**2d0 + 2d0*Ten244*coupl(nGC_54)**2d0  &
                 + 2d0*Ten245*coupl(nGC_33)**2d0 + 2d0*Ten248*coupl(nGC_2)**2d0&
                 + 2d0*Ten249*coupl(nGC_54)**2d0 + 2d0*Ten250*coupl(nGC_33)**  &
                2d0 - 4d0*Ten255*cMU_reg**2d0*coupl(nGC_2)**2d0 + 4d0*Ten260*  &
                cMU_reg**2d0*coupl(nGC_2)**2d0 + pi**2d0*(-coupl(nGC_2)**2d0/pi&
                **2d0 - coupl(nGC_33)**2d0/pi**2d0 - coupl(nGC_54)**2d0/pi**2d0&
                ))/(16d0*pi**2d0)
    dZuL_QED2 = cone*real(dZuL_QED2,kind=dp)
  end if 
end subroutine set_ctparameter74
end module ctparameter74
